Summary:   Dynamic Host Control Protocol Server and Clients
Name:      dhcp-ddns
%define    realname     dhcp
Version:   3.0b1pl17
Release:   1
Source0:   ftp://ftp.isc.org/isc/dhcp/%{realname}-%{version}.tar.gz
Source1:   dhcpd.init
Source2:   make-dhcpd.conf
Patch0:    dhcp-ddns.patch
# Source3:   make-dhcpd.conf.1
Copyright: distributable
Group:     Networking/Daemons
Prereq:    /sbin/chkconfig
Requires:  bind >= 8.2.2
Obsoletes: dhcp3, dhcpd, dhcp
BuildRoot: /tmp/%{name}-%{version}-root
Packager:  Nick Urbanik <nicku@vtc.edu.hk>
URL:       http://www.isc.org/dhcp.html
Prefix:    /usr
Prefix:    /var
Prefix:    /etc

%description
This is the third release of the dhcp package from the Internet Software
Consortium. It provides a server and a relay agent. It is in the beta
stage, but has so many great features and Ted has done a good job with
it, that I will not settle for just version 2.  This version supports
dynamic updates, but will not work with any bind less than bind-2.2.2.

The Internet Software Consortium DHCP Server, dhcpd, implements the
Dynamic Host Configuration Protocol (DHCP) and the Internet Bootstrap
Protocol (BOOTP).  DHCP allows hosts on a TCP/IP network to request
and be assigned IP addresses, and also to discover information about
the network to which they are attached.  BOOTP provides similar
functionality, with certain restrictions.

Also comes with a Perl program to read Excel spreadsheets containing
client data, and generate dhcpd.conf giving static addresses for those
clients.  NOT from the ISC--written by this humble packager.

%package client
Summary:   Dynamic Host Configuration Protocol Client
Group:     Networking/Utilities
Obsoletes: dhcp-client, dhcp3-client, dhcpcd, pump

%description client
This is the third release of the dhcp package from the Internet
Software Consortium. It provides a client.  It's in the beta
stage, but has so many great features and Ted has done a good job with
it, that I won't make do with version 2.

The Internet Software Consortium DHCP Client, dhclient, provides a
means for configuring one or more network interfaces using the Dynamic
Host Configuration Protocol, BOOTP protocol, or if these protocols
fail, by statically assigning an address.

To use this client with RH 6.2 instead of pump, you may simply edit
/sbin/ifup:
92c92
<     if /sbin/pump $PUMPARGS -i $DEVICE ; then
---
>     if /sbin/dhclient -i $DEVICE ; then
and comment out in /sbin/ifdown:
42,44c42,44
< if [ "$BOOTPROTO" = bootp -o "$BOOTPROTO" = dhcp ]; then
<       pump -r -i ${DEVICE}
< fi
---
> # if [ "$BOOTPROTO" = bootp -o "$BOOTPROTO" = dhcp ]; then
> #     pump -r -i ${DEVICE}
> # fi
(Or use my initscripts rpm that applies these patches more sensibly)

Now why do Red Hat not use the ISC client instead of juggling various
dhcpcds and pumps?

%prep
%setup -q -n %{realname}-%{version}
%patch -p1 -b .ddns
#cd server
#%patch 
#cd common
# %patch0
# %patch1



%build
./configure --with-nsupdate
make CC="gcc -pipe" DEBUG="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -d $RPM_BUILD_ROOT/usr/bin
install -d $RPM_BUILD_ROOT/usr/man/man1

make DESTDIR=$RPM_BUILD_ROOT FFMANDIR=/usr/man/man5 install

install -m755 $RPM_SOURCE_DIR/dhcpd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/dhcpd
install -m755 $RPM_SOURCE_DIR/make-dhcpd.conf $RPM_BUILD_ROOT/usr/bin

if [ -x /usr/bin/pod2man ]
then
   /usr/bin/pod2man --center=" " $RPM_SOURCE_DIR/make-dhcpd.conf \
   > $RPM_BUILD_ROOT/usr/man/man1/make-dhcpd.conf.1
else
   echo "Oh dear, where is pod2man?"
fi
# Is it simpler (for the user) to just include the man file here?
# install -m755 $RPM_SOURCE_DIR/make-dhcpd.conf.1 $RPM_BUILD_ROOT/usr/man/man1


mkdir -p $RPM_BUILD_ROOT/var/state/dhcp
touch $RPM_BUILD_ROOT/var/state/dhcp/dhcpd.leases
touch $RPM_BUILD_ROOT/var/state/dhcp/dhclient.leases

strip $RPM_BUILD_ROOT/{sbin/*,usr/sbin/*} || :

%post
/sbin/chkconfig --add dhcpd

# Move old lease database to new location
# (But don't overwrite any lease file in the new location.
# This avoids the situation where someone left an old stale lease file
# in /etc which overwrites the current file.)
if [ -f /etc/dhcpd.leases -a ! -f /var/state/dhcp/dhcpd.leases ]; then
	cp -f /etc/dhcpd.leases /var/state/dhcp/dhcpd.leases
fi

if [ ! -f /var/state/dhcp/dhcpd.leases ]; then
	touch /var/state/dhcp/dhcpd.leases
fi

%postun
if [ $1 = 0 ]; then
    # execute this only if we are NOT doing an upgrade
   /sbin/chkconfig --del dhcpd
fi

%post client
# Move old lease database to new location
if [ -f /etc/dhclient.leases -a ! -f /var/state/dhcp/dhclient.leases ]; then
        cp -f /etc/dhclient.leases /var/state/dhcp/dhclient.leases
fi

if [ ! -f /var/state/dhcp/dhclient.leases ]; then
        touch /var/state/dhcp/dhclient.leases
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc ANONCVS COPYRIGHT DOCUMENTATION ISC-LICENSE README RELNOTES
%doc doc/* server/dhcpd.conf
%config /etc/rc.d/init.d/dhcpd
%attr(644,root,man) /usr/man/man1/make-dhcpd.conf.1
%attr(644,root,man) /usr/man/man5/dhcpd.conf.5
%attr(644,root,man) /usr/man/man5/dhcpd.leases.5
%attr(644,root,man) /usr/man/man5/dhcp-options.5
%attr(644,root,man) /usr/man/man5/dhcp-contrib.5
%attr(644,root,man) /usr/man/man5/dhcp-eval.5
%attr(644,root,man) /usr/man/man8/dhcpd.8
%attr(644,root,man) /usr/man/man8/dhcrelay.8
%attr(755,root,root) /usr/bin/make-dhcpd.conf
/usr/sbin/dhcpd
/usr/sbin/dhcrelay
%dir /var/state/dhcp
%ghost /var/state/dhcp/dhcpd.leases

%files client
%defattr(-,root,root)
%doc ANONCVS COPYRIGHT DOCUMENTATION ISC-LICENSE README RELNOTES
%doc doc/* client/dhclient.conf
/etc/dhclient-script
/sbin/dhclient
%attr(644,root,man) /usr/man/man5/dhclient.conf.5
%attr(644,root,man) /usr/man/man5/dhclient.leases.5
%attr(644,root,man) /usr/man/man8/dhclient.8
%attr(644,root,man) /usr/man/man8/dhclient-script.8
%dir /var/state/dhcp
%ghost /var/state/dhcp/dhclient.leases

%changelog
* Sun Jul 25 2000 Nick Urbanik <nicku@vtc.edu.hk>
- version 3.0b1pl17-1
  Updated patches to ifup and ifdown in description for client.

* Sun Jun 25 2000 Nick Urbanik <nicku@vtc.edu.hk>
- version 3.0b1pl14-1

* Sun Nov 14 1999 Nick Urbanik <nicku@vtc.edu.hk>
- version 3.0b1pl12-1
- remove the broadcast address from /etc/rc.d/init.d/dhcpd, since not required
  for 2.2 kernels.  Uncomment in that file if using old kernel.

* Sun Aug 15 1999 Nick Urbanik <nicku@vtc.edu.hk>
- Signed it.

* Sat Aug 14 1999 Nick Urbanik <nicku@vtc.edu.hk>
- Change name to dhcp3 so that it can (hopefully) finally make it into
  contrib.redhat.com
- Modified dhcpd.init to not put down linux.

* Thu Aug 01 1999 Nick Urbanik <nicku@vtc.edu.hk>
  [3.0b1pl0-2]
- add fact that pump is obsoleted by the client.

* Thu Jul 08 1999 Nick Urbanik <nicku@vtc.edu.hk>
  [3.0b1pl0-1]
  Hooray! It is no longer alpha.

* Tue Apr 27 1999 Nick Urbanik <nicku@vtc.edu.hk>
  [3.0-alpha-19990608]
- Horrible work arounds in this spec file to allow the - sign to exist.

* Tue Apr 27 1999 Nick Urbanik <nicku@vtc.edu.hk>
  [3.0-alpha-19990423]
- Ted Lemon (the author) sent a patch to the dhcp-server mailing list.
  Included here.  Essential to prevent server from crashing with DHCPINFORM

* Sun Apr 18 1999 Nick Urbanik <nicku@vtc.edu.hk>
  [3.0-alpha-19990412]
- Ted Lemon (the author) sent a patch to the dhcp-server 

* Thu Apr 15 1999 Nick Urbanik <nicku@vtc.edu.hk>
  [2.0b1pl26]
- Ted Lemon noted my man patch, and has applied it to the isc source.

* Tue Apr 06 1999 Nick Urbanik <nicku@vtc.edu.hk>
  (Hopefully not the idiot mentioned in such caustic terms below  :-)
- Fixed a minor bug where man pages were put into the man directories
  in cat form rather than nroff form.
- Removed -q from dhcpd.init, just to see it start up when booting.

* Sat Mar 06 1999 Arne Coucheron <arneco@online.no>
  [2.0b1pl18-1]
- lease databases moved to /var/state/dhcp

* Wed Feb 24 1999 Arne Coucheron <arneco@online.no>
  [2.0b1pl14-2]
- no changes, just rereleasing it since some idiot doesn't follow common
  sense, but completely ruins the work that other people does

* Sun Feb 21 1999 Arne Coucheron <arneco@online.no>
  [2.0b1pl14-1]
- using DESTDIR when doing install

* Thu Feb 18 1999 Arne Coucheron <arneco@online.no>
  [2.0b1pl13-1]

* Sat Jan 16 1999 Arne Coucheron <arneco@online.no>
  [2.0b1pl8-1]

* Sun Sep 06 1998 Arne Coucheron <arneco@online.no>
  [2.0b1pl6-2]
- added CC="gcc -pipe" to make in the %build section

* Sat Jun 27 1998 Arne Coucheron <arneco@online.no>
  [2.0b1pl6-1]
- using %%{name} and %%{version} macros
- added -q parameter to %setup
- cleaned out some changelog entries
- changed name of spec file to dhcp.spec

* Tue May 19 1998 Arne Coucheron <arneco@online.no>
  [2.0b1pl1-1]
- using %defattr, requires rpm 2.5 to build now
- removed glibc patch, fixed in sources